#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>
#include <unistd.h>
#define QSPV
#include "spv.h"

typedef struct mitem
{
    short len;
    char chrs[1];
} MITEM;

#define RETITM  39

int menu (struct WM_wwork *, char *, LLIST **, int, int, int, int, int, 
	  struct WM_litm *, int);

static long MACT (struct WM_wwork *, struct WM_menw *, char *, short, short);
static long MDRAW (struct WM_wwork *, struct WM_menw *);

static struct WM_action mdraw = {JSR, wm_drwaw, MDRAW};
static struct WM_action mact = {JSR, wm_actme, MACT};

#define MAX_SECT    1
#define MAX_YSIZE   120

static struct WM_info d_info[2] =	/* information objects */
{
    {10, 10,			/* xsize, ysize         size */
     2, 0,			/* xorg, yorg           and origin */
     TYP_TEXT, 0,		/* type, spare          item type */
     {1, 0, 0},			/* ink, cwid, chgt      character attributes */
     NULL},			/* *pobj                pointer to object */
    {-1, -1}
};

static struct WM_infw d_infw[3] =
{
    {0, 14,			/* xsize, ysize    size */
     0, 0,			/* xorg, yorg      and origin */
     0,				/* flag            no clear + shadow */
     0, 0, 84,			/* borw, borc, papr border width/clr, paper */
     NULL},			/* *pobj            pointer to object list */

    {10, 10,			/* xsize, ysize     size */
     4, 2,			/* xorg, yorg       and origin */
     0,				/* flag             no clear + shadow */
     0, 0, 7,			/* borw, borc, papr border width/clr, paper */
     NULL},			/* *pobj            pointer to object list */
    {-1, -1}
};


static struct WM_menw d_mw =	/* menu window */
{
    0, 0,			/* xsize, ysize         size */
    2, 14,			/* xorg, yorg           and origin */
    0,				/* flag                 no clear + shadow */
    1, 4, 7,			/* borw, borc, papr border width/clr, paper */
    NULL,			/* *pspr                pointer to sprite */
    &mdraw,			/* *draw                draw routine */
    wm__mhit,			/* *hit                 hit routine */
    wm__pnsc,			/* *ctrl                control routine */
    0, 0,			/* nxsc, nysc           max x,y sections */
    0, 0, 0,			/* skey, 2 spare        selection keystroke */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    2, 0, 7,			/* psac, psbc, pssc arrow/bar clrs */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    2, 0, 7,			/* psac, psbc, pssc arrow/bar clrs */
    NULL,			/* *mstt                menu status area */
    1, 2,			/* curw, curc    current item width/clr */
    7, 127, NULL, NULL,		/* uback, uink, *ublob, *upatt unavail */
    7, 0, NULL, NULL,		/* aback, aink, *ablob, *apatt  avail */
    0, 7, NULL, NULL,		/* sback, sink, *sblob, *spatt selected */
    1, 0,			/* ncol, nrow           columns and rows */
    0, 0,			/* xoff, yoff           window offset */
    {0,0},			/* -xsize, -xspce     or *xspc spacing list */
    {-10,-12},			/* -ysize, -yspce     or *yspc spacing list */
    NULL, NULL,			/* *xind, *yind         not implemented */
    NULL			/* *rowl                row list */
};

static struct WM_wwork d_ww =	/* window working definition */
{
    NULL,			/* *wstat;         pointer to status area */
    NULL,			/* *wscale         this was pointer to WDEF */
    0,				/* chid            channel ID */
    NULL,			/* *pprec          pointer to pointer record */
    0,				/* psave           pointer position saved */
    0, 0, 0, 0,			/* 4 zero */
    NULL,			/* *splst          pointer to sprite list */
    0, 0,			/* xsize, ysize will need changing */
    0, 0,			/* xorg, yorg      and origin */
    NO_WCLEAR + 2,		/* flag            no clear + shadow */
    1, 4, 84,			/* borw, borc, papr border width/clr, paper */
    NULL,			/* *sprite          pointer to sprite */
    1, 0,			/* curw, curc      current item width/clr */
    7, 4, NULL, NULL,		/* uback, uink, *ublob, *upatt  unavail */
    7, 0, NULL, NULL,		/* aback, aink, *ablob, *apatt  avail */
    4, 0, NULL, NULL,		/* sback, sink, *sblob, *spatt  selected */
    NULL,			/* *help */
    2, 1, NULL,			/* ninfo, ninob, *pinfo info winds */
    0, NULL,			/* nlitm, *plitm        loose items */
    1, NULL			/* nappl  *pappl        appl winds */
};

extern void *xmalloc(int);
extern void xfree(void *);


void menu_chks (struct WM_menw *menu)
{
    struct WM_pwcb *pwcb;
    struct WM_splst *xl, *yl;

    short spacing;
    int i;
    
    pwcb = menu->ypwcb;		/* part window control block (scroll) */
    spacing = -menu->ys.c._spce;

    if (menu->nrow > menu->ysize / spacing)
    {
	if (pwcb->nsec == 0)
	    menu->xsize -= WW_XBAR;	/* adjust width for bar */
	pwcb->nsec = 1;		/* one section */
	pwcb->s[0].stt = 0;	/* from zero */
	pwcb->s[0].siz = ((menu->ysize - WW_YARROW * 2) / spacing); /* size */
	menu->yoff = WW_YARROW;	/* offset for arrows */
    }
    else
    {
	if (pwcb->nsec)
	    menu->xsize += WW_XBAR;	/* adjust width for no bar */
	pwcb->nsec = 0;		/* no sections */
	menu->yoff = 0;		/* no arrows, no offset */
    }
    menu->xs.c._spce = -(menu->xsize) / menu->ncol;   /* width of each column */
    menu->xs.c._size = menu->xs.c._spce + menu->curw * 4;  /* ... item border */
}

void menu_rems (struct WM_menw *menu)
{
    struct WM_pwcb *pwcb;

    pwcb = menu->ypwcb;		/* part window control block (scroll) */

    if (pwcb->nsec)
    {
	menu->xsize += WW_XBAR;	/* adjust width for no bar */
	pwcb->nsec = 0;		/* no sections */
	menu->yoff = 0;
    }				/* no arrows, no offset */
}


void LoadMenu (struct WM_menw *menu, LLIST *list, struct WM_action *act)
{
    int i;
    struct WM_rowl *rowl;
    struct WM_mobj *mobj;
    char *mstt;
    LLIST *p;
    int nitem;
    int nsize;
 
    for (p = list, nitem = 0; p; p = p->next, nitem++)
	;			/* NULL LOOP to find nitems */

    if (menu->rowl)
    {
	xfree (menu->rowl);
    }

    menu->rowl = NULL;
    menu->ncol = 1;
    menu->nrow = nitem;

    nsize = (sizeof (struct WM_rowl) + sizeof (struct WM_mobj) + 
                             sizeof (struct WM_mobj) + 1) * nitem;

    menu->rowl =       /* allocate all working space in a lump */
    rowl = (struct WM_rowl *) xmalloc
      ((int)((sizeof(struct WM_rowl) + sizeof(struct WM_mobj) + 1) * nitem));
    mobj = (struct WM_mobj *)
          (((char *) rowl) + sizeof(struct WM_rowl) * nitem);
    menu->mstt =
    mstt = ((char *) mobj) + sizeof(struct WM_mobj) * nitem;

    for (i = 0; i < nitem; i++)	/* initialise menu structures */
    {
	mobj->xjst = 1;
	mobj->yjst = 0;
	mobj->type = 0;
	mobj->skey = 0;
	mobj->pobj = (char *) ((MDEF *) list->item)->qtext;
	mobj->item = i;
	if (((MDEF *) list->item)->action == NULL)
	{
	    mobj->pact = act;
	}
	else
	{
	    mobj->pact = ((MDEF *) list->item)->action;
	}
	if (((MDEF *) list->item)->skey > 0)
	{
	    mobj->skey = ((MDEF *) list->item)->skey;
	}
	else if (((MDEF *) list->item)->skey < 0)
	{
            mobj->type += ((MDEF *) list->item)->skey;
	    mobj->skey = *(((struct QD_text *) mobj->pobj)->chrs
			   - (((MDEF *) list->item)->skey + 1));
	    if (mobj->skey > 'Z')
	    {
		mobj->skey -= ' ';
	    }
	}

	rowl->rows = mobj++;	/* one object per row */
	(rowl++)->rowe = mobj;
	*(mstt++) = ((MDEF *) list->item)->status;
	list = list->next;	/* next text */
    }
}


int menu (struct WM_wwork *wwk, char *prompt, LLIST **MList, int icount,
	  int xoff, int yoff, int xsize, int ysize, 
	  struct WM_litm *plitem,
	  int nlitem)
{

    short pr_w = 0;
    struct WM_wstat ws;
    struct WM_info info[2];
    struct WM_infw infw[3];
    struct WM_menw mw;
    struct WM_appl appl[2];
    struct WM_wwork ww;
    struct WM_litm *ppl;
    short last;
    int rval;
    short yf,flg;
    int ns;
    WM_PWCB (2) pwcy;
    QD_text_t *ptitle;

    flg = 0;

    ns = (1+nlitem) * sizeof(struct WM_litm);
    ppl = xmalloc(ns);

    memcpy(ppl, plitem, ns);

    memset (&pwcy, '\0', sizeof (pwcy));
    memcpy (info, d_info, sizeof (d_info));

    memcpy (infw, d_infw, sizeof (d_infw));
    infw[1].pobl = info;

    memcpy (&mw, &d_mw, sizeof (d_mw));
    appl[0].pappw = (struct WM_appw *) &mw;
    appl[1].pappw = NULL;

    memcpy (&ww, &d_ww, sizeof (d_ww));
    memset (&ws, '\0', sizeof (ws));
    ws.litem[RETITM] = 0;
    ww.pappl = ww.splst = appl;
    ww.pinfo = infw;
    ww.plitm = ppl;
    ww.nlitm = nlitem;

    ws.wmode = FORM_QL4;
    ws.wwork = &ww;		/* cross references */
    ww.wstat = &ws;
    
    if (ysize == 0)
    {
        ysize = icount * 12;
    }

    if(ysize > (wwk->ysize - 4) - 30)
    {
        ysize = 12*(((wwk->ysize - 4) - 30)/12) ;
        flg = 1;
        yoff = 0;
    }


    pr_w = strlen(prompt);
    ptitle = xmalloc(pr_w + 8);
    ptitle->len = pr_w;
    memcpy(ptitle->chrs, prompt, pr_w);

    pr_w = (pr_w + 1) * 6;

    info[0].pobj = ptitle;
    info[0].xsize = pr_w - 6;	/* String length */
    infw[0].xsize = xsize;
    infw[1].xsize = pr_w;	/* outer wight window */

    last = nlitem - 1;
    (ppl+last)->xorg = xsize - (ppl+last)->xsize - 4;

    LoadMenu (&mw, *MList, &mact);

    ww.xsize = xsize;
    mw.xsize = xsize - 4;

    mw.ysize = ysize;
    ww.ysize = 15 + mw.ysize;
    mw.nysc = MAX_SECT;
    mw.ypwcb = (struct WM_pwcb *) &pwcy;
    ww.xorg = 4;
    ww.yorg = 15 + 8;
    
    ws.citem = -1;		/* no current item  */
    ws.ciact = NULL;		/* or current item routine */
#if 0
    if(mono)
    {
        mw.ypsac = 7;
        mw.sback = 7;
        mw.sink = 0;
        mw.curc = 7;
        ww.borc = mw.borc = 7;        
        ww.uink = 0;            
        ww.sback =7;
        infw[0].papr = ww.papr = 127;
    }
#endif
    if(yoff == 0)
    {
        yf = (wwk->ysize - 4 - ww.ysize)/2;
    }
    else
    {
        yf = yoff;
    }
    
    wm_pulld (&ww, wwk->xorg + xoff, wwk->yorg + yf);	/* pull down */
    wm_wdraw (&ww);

    while (!wm_rptr (&ww))
    {
	if (ws.evnt & PT_CAN)
	    break;
	if (ws.evnt & PT_WMOVE)
	{
	    menu_rems (&mw);
	    LoadMenu (&mw, *MList, &mact);
	    wm_swapp (&ww, 0, -1);
	    sd_clear (ww.chid, -1);
	    MDRAW (&ww, &mw);
	}
    }
    rval = ws.litem[RETITM];

    if(mw.rowl)
    {
        xfree (mw.rowl);
    }

    mw.rowl = NULL;
    wm_cluns (&ww);		/* throw it away */

    xfree(ppl);
    xfree(ptitle);

    return rval;
}

static long MDRAW (struct WM_wwork *wwk, struct WM_menw *mw)
{

    menu_chks (mw);
    wm_index (wwk, (struct WM_swdef *) mw);
    wm_mdraw (wwk, (struct WM_swdef *) mw, 0);
}

static long MACT (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, 
		  short col, short row)
{
    struct WM_mobj *mobj;

    mobj = mw->rowl[row].rows;	/* current menu object */
    wwk->wstat->litem[RETITM] = mobj->item;
    return PT__CAN;
}

static void AddMenu (LLIST ** pX, char *q, short nl, char *xtra)
{
    MITEM *s;
    MDEF *pm;
    LLIST *pl;
    short n;
    char *l;

    n = strlen (q);
    s = (MITEM *) malloc (n + 8);
    s->len = n;
    strcpy (s->chrs, q);
    pm = (MDEF *) malloc (sizeof (MDEF));
    pm->qtext = (struct QD_text *) s;
    pm->retval = 0;
    pm->action = NULL;
    pm->skey = nl;
    pl = (LLIST *) malloc (sizeof (LLIST));
    pl->item = pm;
    pl->next = *pX;
    if(xtra)
    {
	strcpy(pl->extra, xtra);
	pm->status = WSI_UNAV;
    }
    else
    {
	pm->status = WSI_AVBL;
    }

    (*pX) = pl;
}

typedef struct
{
    char    *prog;
    char    *comstr;
    long    inchid;
    long    ouchid;
    long    owner;
    long    stde;
    short   wait;
    char    prio;
} QFORK;


int qfork (QFORK *qf)
{
    int jobid;
    void *jobaddr;
    struct JOBHEADER *jh;                   /* ha ha */
    short elen, nlen;
    long codsiz;
    chanid_t chid;
    int rv = -1;
    
    if((rv = io_open(qf->prog, 0)) > 0)
    {
	struct qdirect qdir;
	
	chid = rv;
	if((rv = fs_headr(chid, -1, &qdir, sizeof(qdir))) > 0)
	{
	    if(qdir.d_type == QF_PROG_TYPE)
	    {
		jobid = mt_cjob(qdir.d_length, qdir.d_datalen, NULL, -1, 
				&jobaddr);
		if(jobid > 0)
		{
		    void *stk;
		    
		    if((rv = fs_load(chid, jobaddr, qdir.d_length)) > 0)
		    {
			char *cmd;
			cmd = qf->comstr;
			io_close(chid); chid = 0;
			
			jh = (((struct JOBHEADER *)jobaddr) - 1);
			stk = (void *) jh->jb_regs.jb_A7;
			if(cmd && (nlen = strlen(cmd)))
			{
			    elen = (nlen+1) & ~1;
			}
			else
			{
			    nlen = elen = 0;
			} 

			elen = elen + (3 << 2);     /* 3 channels */
			((char *)stk) -= elen;
			(void *) jh->jb_regs.jb_A7 = stk;
			*((short *) stk)++ = 3;
			*((long *) stk)++ = qf->inchid;
			*((long *) stk)++ = qf->stde;
			*((long *) stk)++ = qf->ouchid;

			*((short *)stk)++ = nlen;
			while (nlen--)
			{
			    *((char *)stk)++ = *cmd++;
			}
			rv = mt_activ(jobid, qf->prio, qf->wait);
			
			if(rv == 0)
			{
			    qf->owner = jobid;
			}
		    }
		    else
		    {
			mt_frjob(jobid, rv);
		    }
		}
	    }
	    else
	    {
		rv = -15;
	    }
	}
	if(chid > 0)
	{
	    io_close(chid);
	}
    }
    return rv;
}


int qsystem(char *cmd, PICVIEW *pv)
{
    QFORK qf;
    char *p = NULL, *q = NULL, *nul;
    int mych;
    int rv;
    
    int mypid = getpid();
    if(p = strchr(cmd, ' '))
    {
        *p = 0;
        q = p + 1;
    }

    if((nul = getenv("SLSPV_NUL")) == NULL)
    {
	nul = "nul";
    }
    qf.ouchid = io_open("pipe_512", 3);
    pv->chi = io_open("pipe_0", qf.ouchid);
    qf.wait = 0;
    pv->cho = io_open("pipe_4096", 3);
    qf.inchid = io_open("pipe_0", pv->cho);
    qf.stde = io_open(nul, 3);
    qf.prog = cmd;
    qf.comstr = q;
    qf.owner = mypid;
    qf.prio = 16;

    rv = qfork(&qf);
    pv->pid = qf.owner;
    return rv;
}

extern void Report (char *ctl,...);

void BuildMenu(PICVIEW *pv)
{
    LLIST *pl;
    QFORK *qf;
    int sts;
    char buf[256], *p, *l;

    pv->mwidth = 12;
    pv->nmenu = 2;
    AddMenu (&pv->pX, "Exit", -1, NULL);    
    if((p = getenv("SLSPV_UNPIC")))
    {
	strcpy(buf, p);
	if(qsystem(buf, pv) == 0)
	{
	    sts = io_fline(pv->chi, 250, buf, sizeof(buf)); 
	    if(sts > 0)
	    {
		char *q,xtra[4], *px, abrv, tmp[80];
		short nl;
		for(p = buf; *p; p = p + strlen(p) + 1)
		{
		    q = p;
		    abrv = *q;
		    q++;q++;
		    for(px = xtra; *q != ':'; q++)
		    {
			*px++ = *q;
		    }
		    *px = 0;
		    q++;
		
		    if((l = strchr(q, abrv)))
		    {
			nl = (q-l) - 9;
		    }
		    else
		    {
			nl = 0;
		    }
		    strcpy(tmp, "Save as ");
		    strcat(tmp, q);
		    AddMenu (&pv->pX, tmp, nl, xtra);
		    pv->nmenu++;
		    if( strlen(tmp)+2 > pv->mwidth)
			pv->mwidth = strlen(tmp)+2;
		}
	    }
	}
    }
    AddMenu (&pv->pX, "Open", -1, NULL);
    pv->mwidth *= 6;
}
